/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.stp.core.internal.saf.impl;

/**
 *
 */
public interface ISAFConstants {
	
	// Plugin ID (value must match that used in plugin.xml).
	public static final String PLUGIN_ID             = "org.eclipse.stp.core.saf"; //$NON-NLS-1$
	
	// Extension point identifier, which needs to be kept in synch with plugin.xml.
	public static final String HANDLERS_EXT_POINT_ID = "handlers"; //$NON-NLS-1$
	public static final String CONTEXT_EXT_POINT_ID = "context"; //$NON-NLS-1$
	public static final String CONTEXTEXTENSION_EXT_POINT_ID = "contextExtension"; //$NON-NLS-1$
	

	// Values used by the component implemenation handler extension point schema;
	// therefore, they need to be kept in synch with handler.exsd.
	public static final String COMPONENT_HANDLER_TAG 	    = "componentHandler";//$NON-NLS-1$
	public static final String EXTERNAL_SERVICE_HANDLER_TAG = "externalServiceHandler";//$NON-NLS-1$
	public static final String ENTRY_POINT_HANDLER_TAG      = "entryPointHandler";//$NON-NLS-1$
	public static final String INTERFACE_HANDLER_TAG    = "interfaceHandler";//$NON-NLS-1$
	public static final String KIND_ATTR         = "kind";//$NON-NLS-1$
	public static final String DESC_KIND_NAME_ATTR  = "descriptiveKindName";//$NON-NLS-1$	
	public static final String NAME_ATTR         = "name";//$NON-NLS-1$
	public static final String DESCRIPTION_ATTR  = "description";//$NON-NLS-1$
	public static final String SMALL_ICON_ATTR   = "smallIcon";//$NON-NLS-1$
	public static final String LARGE_ICON_ATTR   = "largeIcon";//$NON-NLS-1$
	public static final String CLASS_ATTR        = "class";//$NON-NLS-1$
	
	// Values used by the context filter extension point schema;
	// therefore, they need to be kept in synch with context.exsd.
	public static final String CONTEXT_TAG                   		= "context";//$NON-NLS-1$
	public static final String CONTEXT_EXTENSION_TAG        		= "contextExtension";//$NON-NLS-1$
	public static final String CONTEXT_KEY_TAG               		= "contextKey";//$NON-NLS-1$
	public static final String COMPONENT_KIND_CONSTRAINT_TAG 		= "componentKindConstraint";//$NON-NLS-1$
	public static final String ENTRY_POINT_KIND_CONSTRAINT_TAG      = "entryPointKindConstraint";//$NON-NLS-1$
	public static final String EXTERNAL_SERVICE_KIND_CONSTRAINT_TAG = "externalServiceKindConstraint";//$NON-NLS-1$
	public static final String EXTENSIBLE_ATTR      = "extensible";//$NON-NLS-1$
	public static final String KINDS_ATTR           = "kinds";//$NON-NLS-1$
	public static final String INCLUDE_KINDS_ATTR   = "includeKinds";//$NON-NLS-1$
	public static final String NAMESPACE_ATTR       = "namespace";//$NON-NLS-1$
	public static final String ROOT_TYPE_ATTR       = "rootType";//$NON-NLS-1$
	public static final String SUB_TYPE_ATTR        = "subType";//$NON-NLS-1$
 
 
}//ISAFConstants

