/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.stp.core.sca;

import org.eclipse.emf.ecore.util.FeatureMap;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Module Wire</b></em>'.
 * 
 * <p>
 * This interface is not intended to be implemented by clients.
 * </p>
 * <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.stp.core.sca.ModuleWire#getSourceUri <em>Source Uri</em>}</li>
 * <li>{@link org.eclipse.stp.core.sca.ModuleWire#getTargetUri <em>Target Uri</em>}</li>
 * <li>{@link org.eclipse.stp.core.sca.ModuleWire#getAny <em>Any</em>}</li>
 * <li>{@link org.eclipse.stp.core.sca.ModuleWire#getAnyAttribute <em>Any Attribute</em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.stp.core.sca.SCAPackage#getModuleWire()
 * @model extendedMetaData="name='ModuleWire' kind='elementOnly'"
 * @extends SCAObject
 * @generated
 */
public interface ModuleWire extends SCAObject {
   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   String copyright = "Copyright (c) 2005, 2006 IBM Corporation. Licensed Material - Property of IBM. All rights reserved."; //$NON-NLS-1$

   /**
    * Returns the value of the '<em><b>Source Uri</b></em>' attribute. <!--
    * begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Source Uri</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * 
    * @return the value of the '<em>Source Uri</em>' attribute.
    * @see #setSourceUri(String)
    * @see org.eclipse.stp.core.sca.SCAPackage#getModuleWire_SourceUri()
    * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.AnyURI"
    *        required="true" extendedMetaData="kind='element' name='source.uri'
    *        namespace='##targetNamespace'"
    * @generated
    */
   String getSourceUri();

   /**
    * Sets the value of the '{@link org.eclipse.stp.core.sca.ModuleWire#getSourceUri <em>Source Uri</em>}'
    * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @param value
    *           the new value of the '<em>Source Uri</em>' attribute.
    * @see #getSourceUri()
    * @generated
    */
   void setSourceUri(String value);

   /**
    * Returns the value of the '<em><b>Target Uri</b></em>' attribute. <!--
    * begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Target Uri</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * 
    * @return the value of the '<em>Target Uri</em>' attribute.
    * @see #setTargetUri(String)
    * @see org.eclipse.stp.core.sca.SCAPackage#getModuleWire_TargetUri()
    * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.AnyURI"
    *        required="true" extendedMetaData="kind='element' name='target.uri'
    *        namespace='##targetNamespace'"
    * @generated
    */
   String getTargetUri();

   /**
    * Sets the value of the '{@link org.eclipse.stp.core.sca.ModuleWire#getTargetUri <em>Target Uri</em>}'
    * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @param value
    *           the new value of the '<em>Target Uri</em>' attribute.
    * @see #getTargetUri()
    * @generated
    */
   void setTargetUri(String value);

   /**
    * Returns the value of the '<em><b>Any</b></em>' attribute list. The
    * list contents are of type
    * {@link org.eclipse.emf.ecore.util.FeatureMap.Entry}. <!-- begin-user-doc
    * -->
    * <p>
    * If the meaning of the '<em>Any</em>' attribute list isn't clear, there
    * really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * 
    * @return the value of the '<em>Any</em>' attribute list.
    * @see org.eclipse.stp.core.sca.SCAPackage#getModuleWire_Any()
    * @model unique="false" dataType="org.eclipse.emf.ecore.EFeatureMapEntry"
    *        many="true" extendedMetaData="kind='elementWildcard'
    *        wildcards='##other' name=':2' processing='lax'"
    * @generated
    */
   FeatureMap getAny();

   /**
    * Returns the value of the '<em><b>Any Attribute</b></em>' attribute
    * list. The list contents are of type
    * {@link org.eclipse.emf.ecore.util.FeatureMap.Entry}. <!-- begin-user-doc
    * -->
    * <p>
    * If the meaning of the '<em>Any Attribute</em>' attribute list isn't
    * clear, there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * 
    * @return the value of the '<em>Any Attribute</em>' attribute list.
    * @see org.eclipse.stp.core.sca.SCAPackage#getModuleWire_AnyAttribute()
    * @model unique="false" dataType="org.eclipse.emf.ecore.EFeatureMapEntry"
    *        many="true" extendedMetaData="kind='attributeWildcard'
    *        wildcards='##any' name=':3' processing='lax'"
    * @generated
    */
   FeatureMap getAnyAttribute();

} // ModuleWire
